Macro interessanti per SolidWorks

aldus

Utente Junior
Professione: progettista junior
Software: solidworks inventor autocad
Regione: Emilia Romagna
Ciao Aldus.
Fossi in te lascerei la macro così com'è ed andrei invece a modificare una opzione di SW, in
modo che i multifogli vengano salvati sempre all'interno dello stesso file dwg (come già avviene con i pdf)

Menu file > salva con nome > salva come: DWG > click su Opzioni > Disegno del foglio multiplo > Esporta tutti i fogli in un file

Ciao
ci ho provato ma non li scala e li mette nei fogli in modo strano.
 

aldus

Utente Junior
Professione: progettista junior
Software: solidworks inventor autocad
Regione: Emilia Romagna
Più comodamente si riesce a ricavare la proprietà del modello senza apertura della parte
ricavando il ModelDoc2 direttamente dalla vista del modello, poi hai accesso alle proprietà

Dim swModelRef As SldWorks.ModelDoc2
Set swModelRef = swView.ReferencedDocument

GetThatInfo = swModelRef.GetCustomInfoValue("", CustomInfoValue)
Scusate il disturbo.. e Buon giorno a tutti!
Come faccio a dire quale è la vista principale, dalla quale io voglio pescare le proprietà?
mi spiego...
Ho un assieme di un telaio saldato e voglio prendere le proprietà dal papà dell'albero, quindi in questo caso l'assieme, e non uno dei figli, perchè le parti figlie non hanno nessuna proprietà inserita. Se nel disegno io ho una vista di un figlio quindi parte che è stata inserita per prima il foglio riconosce questa come default e se l'ultimo salvataggio è stato fatto su questo foglio quando esporto pdf e dwg non riesco a prendere le proprietà dell'assieme ma prendo la parte figlia.
Avete qualche consiglio per ottenere sempre la parte dell'assieme padre e non rischiare di avere quelle del figlio?
grazie.
saluti
 

jenuary

Utente Standard
Professione: Progettista e Programmatore VB.Net
Software: Solidworks
Regione: Veneto
Ciao Aldus,
vado a memoria, la macro dovrebbe prendere in automatico la prima vista da cui ne ricava il componente, nel tuo caso è una parte.
Potresti modificare la macro e sostituire quella parte di codice con una preselezione.
In parole povere preselezioni la vista e poi lanci la macro modificata.
 

voodoo78

Utente Junior
Professione: disegnatore cad
Software: catiaV5, NX, TeamCenter, Enovia, Autodesk
Regione: Lazio
Ciao,
avrei l'esigenza di trovare/realizzare una macro che mi permetta di gestire in SW le tavole realizzate con altro cad.
Ovviamente ho a disposizione anche i modelli 3d con cui le tavole sono state create.
Per quanto riguarda i modelli 3d ho visto che si riescono ad aprire senza problemi.
Vorrei però riuscire a recuperare (anche parzialmente) le tavole.
E' fattibile?

Grazie per i suggeimenti
 

jenuary

Utente Standard
Professione: Progettista e Programmatore VB.Net
Software: Solidworks
Regione: Veneto
Ciao,
avrei l'esigenza di trovare/realizzare una macro che mi permetta di gestire in SW le tavole realizzate con altro cad.
Ovviamente ho a disposizione anche i modelli 3d con cui le tavole sono state create.
Per quanto riguarda i modelli 3d ho visto che si riescono ad aprire senza problemi.
Vorrei però riuscire a recuperare (anche parzialmente) le tavole.
E' fattibile?

Grazie per i suggeimenti
L'unica cosa che puoi fare è fare un importazione dal dwg\dxf in una tavola di Solidworks, gli devi dire il formato, l'unità di misura, eventuali livelli ecc., ovviamente è slegata al modello e il risultato è comunque pesante.
 

todde4

Utente registrato
Professione: Progettista Meccanico
Software: Solidworks
Regione: Sardegna
Buongiorno,
Nell'azienda in cui lavoro abbiamo un archivio ufficiale fatto da PDF e DXF per le lamiere che ricaviamo da Solidworks.
Per facilitare il lavoro vorrei sapere se qualcuno ha gia realizzato o mi aiuta a realizzare una macro che possa fare le seguenti operazioni.
Una macro che faccia il salvataggio in PDF della tavola aggiungendo al nome file la proprietà description della parte messa in tavola.
Una macro che quando salvo il PDF mi metta lo stesso come allegato (con lega spuntato) alla tavola slddrw di solidworks (elementi albero nascosti ALLEGATI).
Sono riuscito a trovare solo macro per il salvataggio in PDF senza entrare nei vari menù.
Saluti
 

jenuary

Utente Standard
Professione: Progettista e Programmatore VB.Net
Software: Solidworks
Regione: Veneto
Buongiorno,
Nell'azienda in cui lavoro abbiamo un archivio ufficiale fatto da PDF e DXF per le lamiere che ricaviamo da Solidworks.
Per facilitare il lavoro vorrei sapere se qualcuno ha gia realizzato o mi aiuta a realizzare una macro che possa fare le seguenti operazioni.
Una macro che faccia il salvataggio in PDF della tavola aggiungendo al nome file la proprietà description della parte messa in tavola.
Una macro che quando salvo il PDF mi metta lo stesso come allegato (con lega spuntato) alla tavola slddrw di solidworks (elementi albero nascosti ALLEGATI).
Sono riuscito a trovare solo macro per il salvataggio in PDF senza entrare nei vari menù.
Saluti
Ciao
mi potresti spiegare meglio la seconda macro, non ho capito i passaggi che vuoi fare.
Saluti
 

todde4

Utente registrato
Professione: Progettista Meccanico
Software: Solidworks
Regione: Sardegna
Ciao
mi potresti spiegare meglio la seconda macro, non ho capito i passaggi che vuoi fare.
Saluti
Allora. quando salvo il PDF vorrei che venisse legato alla tavola (deve comparire dentro la cartella allegati)
In pratica vorrei che facesse in automatico l'operazione che vedi nell'immaggine, caricando il PDF appena creato.
 

Allegati

jenuary

Utente Standard
Professione: Progettista e Programmatore VB.Net
Software: Solidworks
Regione: Veneto
Provala

Dim swApp As SldWorks.SldWorks
Dim Part As SldWorks.ModelDoc2
Dim swModelDocExt As SldWorks.ModelDocExtension
Dim boolstatus As Boolean
Dim longstatus As Long, longwarnings As Long
Dim swExportPDFData As SldWorks.ExportPdfData
Dim lerrors As Long
Dim lwarnings As Long
Dim Filename As String
Dim sPathName As String
Sub main()
Set swApp = Application.SldWorks
Set Part = swApp.ActiveDoc
Set swModelDocExt = Part.Extension
sPathName = Part.GetPathName
Filename = Left(sPathName, InStrRev(sPathName, "."))
Filename = Filename & "pdf"
Set swExportPDFData = swApp.GetExportFileData(1)
If swExportPDFData Is Nothing Then MsgBox "Nothing"
swExportPDFData.ViewPdfAfterSaving = False
swExportPDFData.ExportAs3D = False
boolstatus = swModelDocExt.SaveAs(Filename, 0, 0, swExportPDFData, lerrors, lwarnings)
boolstatus = swModelDocExt.InsertAttachment(Filename, True)
End Sub
 

Hisoka

Utente poco attivo
Professione: Disegnatore tecnico
Software: Solidworks 2015, Draftsight
Regione: Veneto
Buongiorno a tutti,

premessa: in azienda per due anni ho sempre salvato tutti i file SW in GoogleDrive ma quando abbiamo ampliato l'ufficio con altre postazioni, il volume di di lavoro ci ha richiesto di passare ad un server

Logicamente abbiamo dovuto cambiare tutti i percorsi dei modelli, tabelle, ecc...e soprattutto delle proprietà personalizzate
Ora succede questo: dal mio Pc, da dove è stato creato tutto, i valori standard nelle celle delle proprietà personalizzate sono rimasti gli stessi; senonché se io vado a vedere in basso a destra (riquadro opzioni del modello) mi trovo, giustamente, il percorso vecchio....dando un semplice salva si aggiorna tutto e tutto ok
Dagli altri Pc quando aprono i disegni le celle sono vuote, per far uscire i valori devono schiacciare in basso a dx opzioni del modello e dare ok....ma per ogni disegno diventa lunga

Ora, dopo tutta questa pappardella (spero di essermi spiegato bene) volevo sapere se esiste un macro/batch che posso lanciare dal mio Pc di notte e che "apra, salvi e chiuda" tutte le parti e assiemi del mio archivio; cosi da avere in un paio di settimane tutto aggiornato. Una specie di solidworks task shoulder che però io non ho avendo solo la licenza standar

Grazie a tutti
 

zhishi

Utente registrato
Professione: farmer
Software: SolidWorks
Regione: SolidWorks
Io ho una XP-Pen Star G640 ...
una figata
per il painting è assolutamente la miglior cosa.
Photoshop cosi come tutti i programmi di painting riconoscono la Tavoletta grafica e attivano una modalita di disegno in base alla pressione che si esercita sulla punta.
Più si schiaccia più il tratto diventa grosso.
Con un pò di esercizio diventa davvero uno strumento potentissimo per texturing.

non so con solidworks che non ho mai provato ma penso che sia la stessa cosa.
 

jenuary

Utente Standard
Professione: Progettista e Programmatore VB.Net
Software: Solidworks
Regione: Veneto
Io ho una XP-Pen Star G640 ...
una figata
per il painting è assolutamente la miglior cosa.
Photoshop cosi come tutti i programmi di painting riconoscono la Tavoletta grafica e attivano una modalita di disegno in base alla pressione che si esercita sulla punta.
Più si schiaccia più il tratto diventa grosso.
Con un pò di esercizio diventa davvero uno strumento potentissimo per texturing.

non so con solidworks che non ho mai provato ma penso che sia la stessa cosa.
Non capisco la pertinenza con le macro...forse hai sbagliato forum?
 

Hisoka

Utente poco attivo
Professione: Disegnatore tecnico
Software: Solidworks 2015, Draftsight
Regione: Veneto
Ciao,
penso che l'addin che avevo costruito SaveBackground 4.0 faccia al caso tuo

https://www.cad3d.it/forum1/threads/solidworks-doppio-salvataggio.46279/page-4

Leggiti la discussione completa dall'inizio, scaricati il pacchetto in Rel. 4.0 e leggi il documento di istruzione contenuto, vedrai che è semplicissimo.

Fammi sapere
Ciao Jenuary,
mi sono mangiato la pausa pranzo ma finalmente ho potuto testare l'applicazione che hai creato
Innanzitutto ha delle funzionalità stratosferiche, posso accorpare tante operazioni che facevo con varie macro usando solo questa....per quanto riguarda il problema che avevo spiegato sopra purtroppo non funziona.
Ho provato su varie cartelle ma niente, le parti e gli assiemi si aprono e vengono salvati ma quando li riapro il percorso indicato sulle opzioni di modello è sempre quello vecchio...se però faccio io salva manualmente, il percorso si aggiorna
Non riesco a capire dove possa essere l'inghippo
 

jenuary

Utente Standard
Professione: Progettista e Programmatore VB.Net
Software: Solidworks
Regione: Veneto
Ciao Hisoka,
potresti allegare qualche immagine dei passaggi che fai,? Non mi è chiaro quali pulsanti vai a premere, intendo i passaggi che fai manualmente per sistemare i file (opzioni del modello, ecc.)